# -*- coding: utf-8 -*-
"""project_18691_s23_starter_notebook.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1-CpLc1Z9ExYd9ILpvwHK0SKNskIQVuCr

# 18-691: Spring 2023 Final Project Python Notebook

# Utility Operations + Functions
"""

import matplotlib.pyplot as plt
import numpy as np
import soundfile
from scipy.fft import fft, fftfreq
from scipy import signal
import IPython.display as ipd
from scipy.io import wavfile
# Feel free to import more modules from NumPy, SciPy & Matplotlib only!

def plot_time_log_fft(y, fs, title=None, magnified=False):
    """
    NOTE: DO NOT MODIFY THIS METHOD. IT HAS BEEN PRE-IMPLEMENTED FOR YOUR CONVENIENCE :)
    
    Plots a signal in the time & frequency domain
    
    :param y: Signal to be plotted
    :param fs: Sampling frequency of the signal (for frequency plot)
    :param title: Title of the entire plot
    :param magnified: If true, plots a magnified version of the time plot
    """
    N = y.shape[0]
    T = 1.0 / fs
    yf = fft(y)
    xf = fftfreq(N, T)[:N // 2]
    yf_plot = 2.0 / N * np.abs(yf[0:N // 2])
    yf_plot[yf_plot < 1e-8] = 0

    fig, ax = plt.subplots(nrows=2)

    if magnified:
        time_plot_length = fs // 160
        ax[0].plot(y[:time_plot_length])
    else:
        ax[0].plot(y)
    ax[1].semilogy(xf, yf_plot)
    if title is not None:
        fig.suptitle(title)
    plt.grid()
    plt.show()

def normalize(x):
    """
    Normalize the passed signal to the range [-1, 1]

    :param x: Signal to be normalized 
    :return: Normalized signal (amplitude is within [-1, 1]
    """
    # TODO: Implement logic
    return NotImplemented

def save_as_wav(x, fs, name):
    """
    NOTE: DO NOT MODIFY THIS METHOD. IT HAS BEEN PRE-IMPLEMENTED FOR YOUR CONVENIENCE :)

    Save a signal as a .wav file
    
    :param x: Signal to be saved
    :param fs: Sampling frequency of the signal
    :param name: File name for the signal to be saved as 
    """
    soundfile.write('{}.wav'.format(name), x, fs)

"""# DSP Functions
## Oversampling, Anti-Aliasing Filter + Downsampling & Clipping Distortion functions

Note: You can modify the arguments of these methods as per your convenience.
"""

def apply_oversample(x, fs, oversampling_factor):
    """
    Oversample a signal by the specified oversampling factor

    :param x: Signal to be oversampled
    :param fs: Original sampling rate of the signal
    :param oversampling_factor: Factory by which signal must be oversampled
    :return: Oversampled signal
    """
    # TODO: Implement logic
    return NotImplemented

def design_antialiasing_filter(window_N, fc, fs, is_fir):
    """
    Create and return an anti-aliasing signal of the passed specifications
    
    :param window_N: Length of the filter window
    :param fc: Cutoff frequency of the filter
    :param fs: Sampling frequency at which the filter is operated
    :param is_fir: Creates an FIR filter if true else IIR
    :return: Filter coefficients
    """
    # TODO: Implement logic
    return NotImplemented


def apply_filter_and_downsample(x, downsampled_fs, downsample_by, window_N):
    """
    Filters the passed signal before downsampling it
    
    :param x: Signal to be filtered & downsampled
    :param downsampled_fs: The sampling rate of the signal after downsampling it
    :param downsample_by: Downsampling factor
    :param window_N: Length of the filter window
    :return: Filtered & downsampled signal
    """
    # TODO: Implement logic
    return NotImplemented

def clipping_distortion(x, fs, C, oversample, oversampling_factor):
    """
    Apply clipping distortion on the signal (refer handout for more details)

    :param x: Signal to be distorted
    :param fs: Sampling frequency of the signal
    :param C: Clipping level (refer handout for more details)
    :param oversample: If true, oversamples the signal before clipping it, then downsamples it back
    :param oversampling_factor: Oversampling factor (relevant only if oversample=True)
    :return: Distorted signal
    """
    # TODO: Implement logic
    return NotImplemented

"""# Load Convolution Reverb Impulse Response (IR)"""

# TODO: Load the RIR provided in the handout. You could use SciPy's wavfile.read (refer online documentation)
# TODO: Should we normalize the RIR here?
# TODO: Visualize the RIR using plot_log_fft(...)
# TODO: Play the RIR using ipd.Audio(...)

"""# Experiments on Test Sine signal

## Create Test Sine signal
"""

# TODO: Load the sinewave test signal .wav file provided in the handout.
# TODO: Visualize the test signal using plot_log_fft(...)
# TODO: Play the test signal using ipd.Audio(...)

"""## Apply Clipping Distortion"""

# TODO: Apply clipping distortion on the test signal (WITH NO OVERSAMPLING)
# TODO: Visualize the distorted test signal using plot_log_fft(...)
# TODO: Save the distorted test signal as .wav file to be submitted in the handout using save_as_wav(...)
# TODO: Play the distorted test signal using ipd.Audio(...)

# TODO: clipping distortion on the test signal (WITH OVERSAMPLING USING A SUITABLE OVERSAMPLING FACTOR)
# TODO: Visualize the distorted test signal using plot_log_fft(...)
# TODO: Save the distorted test signal as .wav file to be submitted in the handout using save_as_wav(...)
# TODO: Play the distorted test signal using ipd.Audio(...)

"""## Apply Convolution Reverb"""

# TODO: Apply convolution reverb on the test signal (should you use OLA/OLS here?)
# TODO: Visualize the reverbed test signal using plot_log_fft(...)
# TODO: Save the reverbed test signal as .wav file to be submitted in the handout using save_as_wav(...)
# TODO: Play the reverbed test signal using ipd.Audio(...)

"""# Experiments on a Music file

## Load Guitar Riff file
"""

# TODO: Load the music .wave file provided in the handout.
# TODO: Visualize the music signal using plot_log_fft(...)
# TODO: Play the music signal using ipd.Audio(...)

"""## Apply Clipping Distortion"""

# TODO: Apply clipping distortion on the music signal (WITH OVERSAMPLING)
# Note: Choose suitable & optimal values for the parameters as per your subjective evaluation.
# TODO: Visualize the distorted music signal using plot_log_fft(...)
# TODO: Save the distorted music signal as .wav file to be submitted in the handout using save_as_wav(...)
# TODO: Play the distorted music signal using ipd.Audio(...)

"""## Apply Convolution Reverb"""

# TODO: Apply convolution reverb on the music signal
# Note: Choose suitable & optimal values for the parameters as per your subjective evaluation.
# TODO: Visualize the reverbed music signal using plot_log_fft(...)
# TODO: Save the reverbed music signal as .wav file to be submitted in the handout using save_as_wav(...)
# TODO: Play the reverbed music signal using ipd.Audio(...)

"""# Great job finishing the project!"""